﻿# -*- coding: utf-8 -*-

BUTTON_L = 1
BUTTON_R = 2
BUTTON_M = 4
BUTTON_X = 5
BUTTON_Y = 6
BUTTON_LL = 151
BUTTON_RR = 152
BUTTON_MM = 153
BUTTON_XX = 154
BUTTON_YY = 155
WHEEL_LEFT  = 136
WHEEL_UP    = 137
WHEEL_RIGHT = 138
WHEEL_DOWN  = 139

KEY_0 = 48
KEY_1 = 49
KEY_2 = 50
KEY_3 = 51
KEY_4 = 52
KEY_5 = 53
KEY_6 = 54
KEY_7 = 55
KEY_8 = 56
KEY_9 = 57

KEY_A = 65
KEY_B = 66
KEY_C = 67
KEY_D = 68
KEY_E = 69
KEY_F = 70
KEY_G = 71
KEY_H = 72
KEY_I = 73
KEY_J = 74
KEY_K = 75
KEY_L = 76
KEY_M = 77
KEY_N = 78
KEY_O = 79
KEY_P = 80
KEY_Q = 81
KEY_R = 82
KEY_S = 83
KEY_T = 84
KEY_U = 85
KEY_V = 86
KEY_W = 87
KEY_X = 88
KEY_Y = 89
KEY_Z = 90

KEY_F1 = 112
KEY_F2 = 113
KEY_F3 = 114
KEY_F4 = 115
KEY_F5 = 116
KEY_F6 = 117
KEY_F7 = 118
KEY_F8 = 119
KEY_F9 = 120
KEY_F10 = 121
KEY_F11 = 122
KEY_F12 = 123
KEY_F13 = 124
KEY_F14 = 125
KEY_F15 = 126
KEY_F16 = 127
KEY_F17 = 128
KEY_F18 = 129
KEY_F19 = 130
KEY_F20 = 131
KEY_F21 = 132
KEY_F22 = 133
KEY_F23 = 134
KEY_F24 = 135

KEY_COMMA = 188
#KEY_- = 189
#KEY_. = 190
#KEY_/ = 191
#KEY_: = 186
#KEY_; = 187
#KEY_@ = 192
#KEY_[ = 219
#KEY_\\ = 220
#KEY_] = 221
#KEY_^ = 222
#KEY__ = 226
KEY_ADD = 107
KEY_BACKSPACE = 8
KEY_DECIMAL = 110
KEY_DELETE = 46
KEY_DIVIDE = 111
KEY_DOWN = 40
KEY_END = 35
KEY_ENTER = 13
KEY_ESCAPE = 27
KEY_UP = 38
KEY_LEFT = 37
KEY_RIGHT = 39
KEY_DOWN = 40
KEY_KANA = 21
KEY_HOME = 36
KEY_INSERT = 45
KEY_LEFT = 37
KEY_MULTIPLY = 106
#KEY_NUM_* = 106
#KEY_NUM_+ = 107
#KEY_NUM_- = 109
#KEY_NUM_. = 110
#KEY_NUM_/ = 111
KEY_NUM_0 = 96
KEY_NUM_1 = 97
KEY_NUM_2 = 98
KEY_NUM_3 = 99
KEY_NUM_4 = 100
KEY_NUM_5 = 101
KEY_NUM_6 = 102
KEY_NUM_7 = 103
KEY_NUM_8 = 104
KEY_NUM_9 = 105
KEY_PAGEDOWN = 34
KEY_PAGEUP = 33
KEY_RETURN = 13
KEY_RIGHT = 39
KEY_SEPARATOR = 108
KEY_SPACE = 32
KEY_SUBTRACT = 109
KEY_TAB = 9
# KEY_半角 = 25
# KEY_変換 = 28
# KEY_漢字 = 25
# KEY_無変換 = 29

class Keymap(object):
    __slots__ = ('__map', )

    @classmethod
    def parse(cls, value):
        if isinstance(value, int):
            return value
        else:
            return cls.parser[value.lower()]

    def __init__(self, map = {}):
        self.__map = {}
        for i in map.items():
            self[i[0]] = i[1]

    def __call__(self, owner, *args):
        try:
            self[args]()
            return True
        except KeyError:
            pass

    def __getitem__(self, pair):
        return self.__map[pair]

    def __setitem__(self, pair, fn):
        if not hasattr(fn, '__call__'):
            raise TypeError(str(fn) + ' is not callable.')
        key = (self.parse(pair[0]),) + pair[1:]
        self.__map[key] = fn

    def __iter__(self):
        return self.__map.iterkeys()

    parser = {
        ',': 188,
        '-': 189,
        '.': 190,
        '/': 191,
        '0': 48,
        '1': 49,
        '2': 50,
        '3': 51,
        '4': 52,
        '5': 53,
        '6': 54,
        '7': 55,
        '8': 56,
        '9': 57,
        ':': 186,
        ';': 187,
        '@': 192,
        '[': 219,
        '\\': 220,
        ']': 221,
        '^': 222,
        '_': 226,
        'a': 65,
        'b': 66,
        'c': 67,
        'd': 68,
        'e': 69,
        'f': 70,
        'g': 71,
        'h': 72,
        'i': 73,
        'j': 74,
        'k': 75,
        'l': 76,
        'm': 77,
        'n': 78,
        'o': 79,
        'p': 80,
        'q': 81,
        'r': 82,
        's': 83,
        't': 84,
        'u': 85,
        'v': 86,
        'w': 87,
        'x': 88,
        'y': 89,
        'z': 90,
        'add': 107,
        'back': 8,
        'backspace': 8,
        'decimal': 110,
        'delete': 46,
        'div': 111,
        'divide': 111,
        'down': 40,
        'end': 35,
        'enter': 13,
        'esc': 27,
        'escape': 27,
        'f1': 112,
        'f2': 113,
        'f3': 114,
        'f4': 115,
        'f5': 116,
        'f6': 117,
        'f7': 118,
        'f8': 119,
        'f9': 120,
        'f10': 121,
        'f11': 122,
        'f12': 123,
        'f13': 124,
        'f14': 125,
        'f15': 126,
        'f16': 127,
        'f17': 128,
        'f18': 129,
        'f19': 130,
        'f20': 131,
        'f21': 132,
        'f22': 133,
        'f23': 134,
        'f24': 135,
        'home': 36,
        'ins': 45,
        'insert': 45,
        'left': 37,
        'mul': 106,
        'multiply': 106,
        'next': 34,
        'num *': 106,
        'num +': 107,
        'num -': 109,
        'num .': 110,
        'num /': 111,
        'num 0': 96,
        'num 1': 97,
        'num 2': 98,
        'num 3': 99,
        'num 4': 100,
        'num 5': 101,
        'num 6': 102,
        'num 7': 103,
        'num 8': 104,
        'num 9': 105,
        'pagedown': 34,
        'pageup': 33,
        'prior': 33,
        'return': 13,
        'right': 39,
        'sep': 108,
        'separator': 108,
        'space': 32,
        'sub': 109,
        'subtract': 109,
        'tab': 9,
        'up': 38,
        '←': 37,
        '↑': 38,
        '→': 39,
        '↓': 40,
        'カナ': 21,
        '半角': 25,
        '変換': 28,
        '漢字': 25,
        '無変換': 29,
    }
