﻿# -*- coding: utf-8 -*-

from brownie import *
import re

def _for_select(parent, *args):
    cls = config.EDITOR
    if not cls:
        cls = TextBox
    return cls(parent, dock=CENTER)

def _for_edit(parent, view):
    r = _for_select(parent, CENTER)
    r.limit(view.path)
    return r

def _readline(prompt, value, view, edit):
    dlg = Dialog(view, size = (320+16, 24+16))
    dlg.name = prompt
    textbox = edit(dlg, view)
    textbox.value = value
    textbox.selection = (0, -1) # select all

    dlg.result = textbox
    return dlg.run()

def _select(view, pattern):
    num = view.select(pattern)
    if num > 0:
        return '%d 個のファイルが選択されました。' % num
    else:
        return ('ファイルが1つも選択されませんでした。', WARNING)

_pattern = '' # the last user input for pattern()

def pattern(view):
    global _pattern
    expr = _readline('ファイル選択: 中間一致 / ワイルドカード', _pattern, view, _for_select)
    if expr:
        _pattern = expr
        return _select(view, expr)

_regex = '' # the last user input for regex()

def regex(view):
    global _regex
    expr = _readline('ファイル選択: 正規表現', _regex, view, _for_select)
    if expr:
        _regex = expr
        return _select(view, re.compile(expr, re.IGNORECASE).match)

_new = '新しいフォルダ' # the last user input for new()

def new(view):
    global _new
    name = _readline('新しいオブジェクトの作成', _new, view, _for_edit)
    if name:
        _new = name
        view.new(name)
